
#include <stdio.h>
#include <tchar.h>
#include <Windows.h>
#include <TlHelp32.h>

DWORD FindConHost()
{
  HANDLE hSnapshot = CreateToolhelp32Snapshot(
    TH32CS_SNAPPROCESS, 0);
  if (hSnapshot == INVALID_HANDLE_VALUE)
    return 0;
  PROCESSENTRY32 proc_entry = {};
  proc_entry.dwSize = sizeof(proc_entry);
  if (!Process32First(hSnapshot, &proc_entry))
    return 0;
  do
  {
    if (_wcsicmp(proc_entry.szExeFile, L"conhost.exe") == 0 && proc_entry.th32ParentProcessID == GetCurrentProcessId())
    {
      return proc_entry.th32ProcessID;
    }
  } while (Process32Next(hSnapshot, &proc_entry));

  return 0;
}

int wmain(int argc, wchar_t** argv)
{
  if (argc < 2)
  {
    printf("No file handle passed on the command line\n");
    return 1;
  }

  DWORD_PTR handle = wcstoul(argv[1], nullptr, 0);

  HANDLE hFile = reinterpret_cast<HANDLE>(handle);
  printf("Passed file handle: %p\n", hFile);
  DWORD pid = FindConHost();
  if (!pid)
  {
    printf("Couldn't find conhost executable\n");
    getchar();
    return 1;
  }

  HANDLE hProcess = OpenProcess(PROCESS_DUP_HANDLE, FALSE, pid);
  if (!hProcess)
  {
    printf("Error opening process\n");
    getchar();
    return 1;
  }

  HANDLE hTarget;
  if (!DuplicateHandle(GetCurrentProcess(), hFile, hProcess, &hTarget, 0, FALSE, DUPLICATE_SAME_ACCESS | DUPLICATE_CLOSE_SOURCE))
  {
    printf("Error duplicating handle\n");
    getchar();
    return 1;
  }

  printf("Duplicated to handle %p\n", hTarget);
  printf("Hit Enter to close and delete executable\n");
  
  getchar();
  return 0;
}
