﻿Import-Module "$PSScriptRoot\NtApi"
$pinfo = $null

try
{
    $config = New-Object NtApi.CreateUserProcess
    $config.CommandLine = "testdll"
    $config.ThreadFlags = "Suspended"
    $path = $PSScriptRoot + "\bin\testdll.dll"

    $pinfo = $config.Start("\??\" + $path)
    
    Write-Host "Created Process:", $pinfo.GetProcessImageName($false)
    $pinfo.Resume() | Out-Null

    regsvr32 $path
}
catch
{
    Write-Host $_.Exception.Message
}
finally
{
    if ($pinfo -ne $null)
    {
        $pinfo.Dispose();
    }
}